
:- dynamic 
    bin/2,
    not_bin/2,
    tin/2,
    not_tin/2,
    on/2,
    not_on/2,
    rain/0,
    not_rain/0,
    eq/2,
    not_eq/2.


templates([bin(_x1, _x2), not_bin(_x3, _x4), tin(_x5, _x6), not_tin(_x7, _x8), on(_x9, _x10), not_on(_x11, _x12), rain, not_rain, eq(_x13, _x14), not_eq(_x15, _x16)]).

preds([pred(on, 2), pred(bin, 2), pred(tin, 2), pred(rain, 0), pred(eq, 2)]).
predOrder([eq, bin, on, tin, rain]).


testOps([op(load, [box, truck, city], class(load(A,B,C), 0.0, preconds([bin(A,C), tin(B,C)]), effects([cond([], [outcome(0.99, addList([on(A,B), not_bin(A,C)]), delList([bin(A,C), not_on(A,B)])), outcome(0.01, addList([]), delList([]))])]))), op(unload, [box, truck], class(unload(D, E), 0.0, preconds([tin(E, F), on(D, E)]), effects([cond([rain], [outcome(0.7, addList([bin(D, F), not_on(D, E)]), delList([not_bin(D, F), on(D, E)])), outcome(0.3, addList([]), delList([]))]), cond([not_rain], [outcome(0.9, addList([bin(D, F), not_on(D, E)]), delList([not_bin(D, F), on(D, E)])), outcome(0.1, addList([]), delList([]))])]))), op(drive, [truck, city], class(drive(G, H), 0.0, preconds([tin(G, I), not_tin(G, H)]), effects([cond([], [outcome(1.0, addList([tin(G, H), not_tin(G, I)]), delList([tin(G, I), not_tin(G, H)]))])])))]).

testPreds([pred(not_bin, [box, city]), pred(not_tin, [truck, city]), pred(not_on, [box, truck]), pred(not_rain, [])]).




% reward([node(3,bin(v1, paris),2,0),node(2,10.0,-1,-1),node(0,0.0,-1,-1)]).
rewardList([reward([node(3,bin(a, paris),2,0),node(2,10.0,-1,-1),node(0,0.0,-1,-1)])]).
% reward([node(3,on(a, v1),2,0),node(2,10.0,-1,-1),node(0,0.0,-1,-1)]).
% reward([node(3,tin(truck, v1),2,0),node(2,10.0,-1,-1),node(0,0.0,-1,-1)]).



ops([load, unload, drive]).

operator(load, [xb, xt, xc], [node(0, 0.0, -1, -1)], [ev(succ, [node(4, rain, 3, 2), node(3, 0.7, -1, -1), node(2, 0.9, -1, -1)]), ev(fail, [node(4, rain, 3, 2), node(3, 0.3, -1, -1), node(2, 0.1, -1, -1)])]).
%operator(load, [xb, xt, xc], [ev(succ, [node(2, 0.99, -1, -1)]), ev(fail, [node(2, 0.01, -1, -1)])]).

operator(unload, [xb, xt], [node(0, 00, -1, -1)], [ev(succ, [node(4, rain, 3, 2), node(3, 0.7, -1, -1), node(2, 0.9, -1, -1)]), ev(fail, [node(4, rain, 3, 2), node(3, 0.3, -1, -1), node(2, 0.1, -1, -1)])]).

operator(drive, [xt, xc], [node(0, 0.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).



most_action_variants(2).

actionDiagParams([xb, xc, xt]).

domainConsts([a, paris]).

%%%%%%%%%%%% TVD: LOAD SUCCESS %%%%%%%%%%%%%%%

tvd(load, succ, bin, [y1, y2], [1, 2], 6, [node(6, eq(y1, xb), 5, 2), node(5, eq(y2, xc), 4, 2), node(4, bin(y1, y2), 3, 0), node(3, tin(xt, y2), 0, 1), node(2, bin(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, succ, bin, [y1, y2], [2, 1], 6, [node(6, eq(y2, xc), 5, 2), node(5, eq(y1, xb), 4, 2), node(4, bin(y1, y2), 3, 0), node(3, tin(xt, y2), 0, 1), node(2, bin(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, succ, on, [y3, y4], [1, 2], 6, [node(6, eq(y3, xb), 5, 2), node(5, eq(y4, xt), 4, 2), node(4, bin(y3, xc), 3, 2), node(3, tin(y4, xc), 1, 0), node(2, on(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, succ, on, [y3, y4], [2, 1], 6, [node(6, eq(y4, xt), 5, 2), node(5, eq(y3, xb), 4, 2), node(4, bin(y3, xc), 3, 2), node(3, tin(y4, xc), 1, 0), node(2, on(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, succ, tin, [y5, y6], [_, _], 2, [node(2, tin(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, succ, rain, [], [], 2, [node(2, rain, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, succ, eq, [y7, y8], [_, _], 2, [node(2, eq(y7, y8), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: LOAD FAILURE %%%%%%%%%%%%%%%

tvd(load, fail, bin, [y1, y2], [_, _], 2, [node(2, bin(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, fail, on, [y3, y4], [_, _], 2, [node(2, on(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, fail, tin, [y5, y6], [_, _], 2, [node(2, tin(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, fail, rain, [], [], 2, [node(2, rain, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(load, fail, eq, [y7, y8], [_, _], 2, [node(2, eq(y7, y8), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: UNLOAD SUCCESS %%%%%%%%%%%%%%%

tvd(unload, succ, bin, [y1, y2], [_, _], 6, [node(6, eq(y1, xb), 5, 2), node(5, bin(y1, y2), 1, 4), node(4, on(y1, xt), 3, 0), node(3, tin(xt, y2), 1, 0), node(2, bin(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(unload, succ, on, [y3, y4], [1, 2], 4, [node(4, eq(y3, xb), 3, 2), node(3, eq(y4, xt), 0, 2), node(2, on(y3, y4), 1, 0), node(1, 1.0, -1 ,-1), node(0, 0.0, -1, -1)]).

tvd(unload, succ, on, [y3, y4], [2, 1], 4, [node(4, eq(y4, xt), 3, 2), node(3, eq(y3, xb), 0, 2), node(2, on(y3, y4), 1, 0), node(1, 1.0, -1 ,-1), node(0, 0.0, -1, -1)]).

tvd(unload, succ, tin, [y5, y6], [_, _], 2, [node(2, tin(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(unload, succ, rain, [], [], 2, [node(2, rain, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(unload, succ, eq, [y7, y8], [_, _], 2, [node(2, eq(y7, y8), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: UNLOAD FAILURE %%%%%%%%%%%%%%%

tvd(unload, fail, bin, [y1, y2], [_, _], 2, [node(2, bin(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(unload, fail, on, [y3, y4], [_, _], 2, [node(2, on(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(unload, fail, tin, [y5, y6], [_, _], 2, [node(2, tin(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(unload, fail, rain, [], [], 2, [node(2, rain, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(unload, fail, eq, [y7, y8], [_, _], 2, [node(2, eq(y7, y8), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%% TVD: DRIVE SUCCESS %%%%%%%%%%%%%%%

tvd(drive, succ, bin, [y1, y2], [_, _], 2, [node(2, bin(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, succ, on, [y3, y4], [_, _], 2, [node(2, on(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, succ, tin, [y5, y6], [2, 1], 5, [node(5, eq(y6, xc), 4, 3), node(4, eq(y5, xt), 1, 2), node(3, eq(y5, xt), 0, 2), node(2, tin(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, succ, tin, [y5, y6], [1, 2], 4, [node(4, eq(y5, xt), 3, 2), node(3, eq(y6, xc), 1, 0), node(2, tin(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, succ, rain, [], [], 2, [node(2, rain, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, succ, eq, [y7, y8], [_, _], 2, [node(2, eq(y7, y8), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: DRIVE FAILURE %%%%%%%%%%%%%%%

tvd(drive, fail, bin, [y1, y2], [_, _], 2, [node(2, bin(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, fail, on, [y3, y4], [_, _], 2, [node(2, on(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, fail, tin, [y5, y6], [_, _], 2, [node(2, tin(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, fail, rain, [], [], 2, [node(2, rain, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(drive, fail, eq, [y7, y8], [_, _], 2, [node(2, eq(y7, y8), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%%% GENERAL BACKGROUND KNOWLEDGE %%%%%%%%%%%%%%%%%%%%%%%%

rule(eq(A, B), [1, 1], [eq(B, A)]).
rule(eq(A, B), [1, 1], [eq(C, D), eq(A,C), eq(B,D)]).

rule(not_eq(A, B), [1, 1], [not_eq(B, A)]).
rule(not_eq(A, B), [1, 1], [not_eq(C, D), eq(A,C), eq(B,D)]).


%%%%%%%%%%%%% DOMAIN SPECIFIC BACKGROUND KNOWLEDGE %%%%%%%%%%%%%%%%%%%%%%%%


rule(eq(C1, C2), [1, 1], [bin(B1, C1), bin(B2, C2), eq(B1, B2)]).
rule(eq(C1, C2), [1, 1], [tin(T1, C1), tin(T2, C2), eq(T1, T2)]).
rule(eq(T1, T2), [1, 1], [on(B1, T1), on(B2, T2), eq(B1, B2)]).


rule(not_eq(C1, C2), [1, 1], [bin(B1, C1), not_bin(B2, C2), eq(B1, B2)]).
rule(not_eq(C1, C2), [1, 1], [tin(T1, C1), not_tin(T2, C2), eq(T1, T2)]).

rule(not_eq(T1, T2), [1, 1], [on(B1, T1), not_on(B2, T2), eq(B1, B2)]).
rule(not_eq(T1, T2), [1, 1], [tin(T1, C1), tin(T2, C2), not_eq(C1, C2)]).

rule(not_eq(B1, B2), [1, 1], [bin(B1, C1), bin(B2, C2), not_eq(C1, C2)]).
rule(not_eq(B1, B2), [1, 1], [on(B1, T1), on(B2, T2), not_eq(T1, T2)]).
rule(not_eq(B1, B2), [1, 1], [bin(B1, _), on(B2, _)]).

rule(bin(B1, C1), [1, 1], [bin(B2, C2), eq(B1, B2), eq(C1, C2)]).

rule(not_bin(B1, _), [1, 0], [on(B2, _), eq(B1, B2)]).
rule(not_bin(B1, C1), [1, 1], [bin(B2, C2), eq(B1, B2), not_eq(C1, C2)]).
rule(not_bin(B1, C1), [1, 1], [not_bin(B2, C2), eq(B1, B2), eq(C1, C2)]).

rule(tin(T1, C1), [1, 1], [tin(T2, C2), eq(T1, T2), eq(C1, C2)]).

rule(not_tin(T1, C1), [1, 1], [tin(T2, C2), eq(T1, T2), not_eq(C1, C2)]).
rule(not_tin(T1, C1), [1, 1], [not_tin(T2, C2), eq(T1, T2), eq(C1, C2)]).


rule(on(B1, T1), [1, 1], [on(B2, T2), eq(B1, B2), eq(T1, T2)]).

rule(not_on(B1, _), [1, 0], [bin(B2, _), eq(B1, B2)]).
rule(not_on(B1, T1), [1, 1], [not_on(B2, T2), eq(B1, B2), eq(T1, T2)]).
rule(not_on(B1, T1), [1, 1], [on(B2, T2), eq(B1, B2), not_eq(T1, T2)]).





getExObjects(Ex, [objects(box, Boxes), objects(truck, Trucks), objects(city, Cities)]) :-
    (all(X, (member(bin(X,_), Ex) ; member(on(X,_), Ex)), Boxes) ; Boxes = []),
    (all(X, (member(tin(X,_), Ex) ; member(on(_,X), Ex)), Trucks) ; Trucks = []),
    (all(X, (member(bin(_,X), Ex) ; member(tin(_,X), Ex)), Cities) ; Cities = []).
