pp(D) :-
    D = [node(I, _, _, _) | _],
    prettyprint(I, D, 0, _).

prettyprint(I, D, Level, Res) :- 
    del(node(I, Lit, -1, -1), D, Res),
    tab(Level),
    write(Lit), write(' - ['), write(I), write(']'), nl,
    !.
prettyprint(I, D, Level, Res) :- 
    del(node(I, Lit, L, R), D, D1),
    tab(Level), 
    write(Lit), write(' - ['), write(I), write(']'), nl,
    Level1 is Level + 5,
    prettyprint(L, D1, Level1, D2),
    prettyprint(R, D2, Level1, Res),
    !.
prettyprint(I, D, Level, D) :- 
    tab(Level),
    write('['), write(I), write(']'), nl.
     
