:- dynamic
    hasType/1,
    not_hasType/1,
    goesIn/2,
    not_goesIn/2,
    filed/1,
    not_filed/1,
    haveF0/0,
    not_haveF0/0,
    haveF1/0,
    not_haveF1/0,    
    haveF2/0,
    not_haveF2/0,    
    haveF3/0,
    not_haveF3/0,    
    haveF4/0,
    not_haveF4/0,    
    eq/2,
    not_eq/2.


templates([hasType(_x1), not_hasType(_x2), goesIn(_x3,_x4), not_goesIn(_x5,_x6), filed(_x7), not_filed(_x8), haveF0, not_haveF0, haveF1, not_haveF1, haveF2, not_haveF2, haveF3, not_haveF3, haveF4, not_haveF4, eq(_x9, _x10), not_eq(_x11, _x12)]).

preds([pred(hasType, 1), pred(goesIn, 2), pred(filed, 1), pred(haveF0, 0), pred(haveF1, 0), pred(haveF2, 0), pred(haveF3, 0), pred(haveF4, 0), pred(eq, 2)]).

predOrder([eq, filed, hasType, goesIn, haveF0, haveF1, haveF2, haveF3, haveF4]).



rewardList([reward([node(3, filed(a), 2, 0), node(2, 600.0, -1, -1), node(0, 0.0, -1, -1)])]).



ops([getType, getFolderF0, getFolderF1, getFolderF2, getFolderF3, getFolderF4, fileF0, fileF1, fileF2, fileF3, fileF4, returnF0, returnF1, returnF2, returnF3, returnF4]).

operator(getType, [xp], [node(0, 0.0, -1, -1)], [ev(evF0, [node(2, 0.2, -1, -1)]), ev(evF1, [node(2, 0.2, -1, -1)]), ev(evF2, [node(2, 0.2, -1, -1)]), ev(evF3, [node(2, 0.2, -1, -1)]), ev(evF4, [node(2, 0.2, -1, -1)])]).
operator(getFolderF0, [], [node(2, 100.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(getFolderF1, [], [node(2, 100.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(getFolderF2, [], [node(2, 100.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(getFolderF3, [], [node(2, 100.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(getFolderF4, [], [node(2, 100.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(fileF0, [xp], [node(1, 1.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(fileF1, [xp], [node(1, 1.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(fileF2, [xp], [node(1, 1.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(fileF3, [xp], [node(1, 1.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(fileF4, [xp], [node(1, 1.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(returnF0, [], [node(0, 0.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(returnF1, [], [node(0, 0.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(returnF2, [], [node(0, 0.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(returnF3, [], [node(0, 0.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(returnF4, [], [node(0, 0.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).




most_action_variants(5).

actionDiagParams([xp]).

domainConsts([a, b, f0, f1, f2, f3, f4]).




testOps([op(getType, [file], class(getType(A), 0.0, preconds([not_hasType(A)]), effects([cond([], [outcome(0.2, addList([hasType(A), goesIn(A, f0)]), delList([not_hasType(A), not_goesIn(A, f0)])), outcome(0.2, addList([hasType(A), goesIn(A, f1)]), delList([not_hasType(A), not_goesIn(A, f1)])), outcome(0.2, addList([hasType(A), goesIn(A, f2)]), delList([not_hasType(A), not_goesIn(A, f2)])), outcome(0.2, addList([hasType(A), goesIn(A, f3)]), delList([not_hasType(A), not_goesIn(A, f3)])), outcome(0.2, addList([hasType(A), goesIn(A, f4)]), delList([not_hasType(A), not_goesIn(A, f4)]))])]))), op(getFolderF0, [], class(getFolderF0, -100.0, preconds([not_haveF0, not_haveF1, not_haveF2, not_haveF3, not_haveF4]), effects([cond([], [outcome(1.0, addList([haveF0]), delList([not_haveF0]))])]))), op(getFolderF1, [], class(getFolderF1, -100.0, preconds([not_haveF0, not_haveF1, not_haveF2, not_haveF3, not_haveF4]), effects([cond([], [outcome(1.0, addList([haveF1]), delList([not_haveF1]))])]))), op(getFolderF2, [], class(getFolderF2, -100.0, preconds([not_haveF0, not_haveF1, not_haveF2, not_haveF3, not_haveF4]), effects([cond([], [outcome(1.0, addList([haveF2]), delList([not_haveF2]))])]))), op(getFolderF3, [], class(getFolderF3, -100.0, preconds([not_haveF0, not_haveF1, not_haveF2, not_haveF3, not_haveF4]), effects([cond([], [outcome(1.0, addList([haveF3]), delList([not_haveF3]))])]))), op(getFolderF4, [], class(getFolderF4, -100.0, preconds([not_haveF0, not_haveF1, not_haveF2, not_haveF3, not_haveF4]), effects([cond([], [outcome(1.0, addList([haveF4]), delList([not_haveF4]))])]))), op(fileF0, [file], class(fileF0(B), -1.0, preconds([haveF0, hasType(B), goesIn(B, f0)]), effects([cond([], [outcome(1.0, addList([filed(B)]), delList([not_filed(B)]))])]))), op(fileF1, [file], class(fileF1(B), -1.0, preconds([haveF1, hasType(B), goesIn(B, f1)]), effects([cond([], [outcome(1.0, addList([filed(B)]), delList([not_filed(B)]))])]))), op(fileF2, [file], class(fileF2(B), -1.0, preconds([haveF2, hasType(B), goesIn(B, f2)]), effects([cond([], [outcome(1.0, addList([filed(B)]), delList([not_filed(B)]))])]))), op(fileF3, [file], class(fileF3(B), -1.0, preconds([haveF3, hasType(B), goesIn(B, f3)]), effects([cond([], [outcome(1.0, addList([filed(B)]), delList([not_filed(B)]))])]))), op(fileF4, [file], class(fileF4(B), -1.0, preconds([haveF4, hasType(B), goesIn(B, f4)]), effects([cond([], [outcome(1.0, addList([filed(B)]), delList([not_filed(B)]))])]))), op(returnF0, [], class(returnF0, 0.0, preconds([haveF0]), effects([cond([], [outcome(1.0, addList([not_haveF0]), delList([haveF0]))])]))), op(returnF1, [], class(returnF1, 0.0, preconds([haveF1]), effects([cond([], [outcome(1.0, addList([not_haveF1]), delList([haveF1]))])]))), op(returnF2, [], class(returnF2, 0.0, preconds([haveF2]), effects([cond([], [outcome(1.0, addList([not_haveF2]), delList([haveF2]))])]))), op(returnF3, [], class(returnF3, 0.0, preconds([haveF3]), effects([cond([], [outcome(1.0, addList([not_haveF3]), delList([haveF3]))])]))), op(returnF4, [], class(returnF4, 0.0, preconds([haveF4]), effects([cond([], [outcome(1.0, addList([not_haveF4]), delList([haveF4]))])])))]).



testPreds([pred(not_hasType, [file]), pred(not_goesIn, [file, folder]), pred(not_filed, [file]), pred(not_haveF0, []), pred(not_haveF1, []), pred(not_haveF2, []), pred(not_haveF3, []), pred(not_haveF4, [])]).




%%%%%%%%%%%% TVD: getType evF0 %%%%%%%%%%%%%%%
tvd(getType, evF0, hasType, [y1], [1], 3, [node(3, eq(y1, xp), 1, 2), node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF0, goesIn, [y1, y2], [_, _], 5, [node(5, eq(f0, y2), 4, 2), node(4, eq(y1, xp), 3, 2), node(3, hasType(xp), 2, 1), node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF0, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF0, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF0, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF0, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF0, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF0, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF0, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: getType evF1 %%%%%%%%%%%%%%%
tvd(getType, evF1, hasType, [y1], [1], 3, [node(3, eq(y1, xp), 1, 2), node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF1, goesIn, [y1, y2], [_, _], 5, [node(5, eq(f1, y2), 4, 2), node(4, eq(y1, xp), 3, 2), node(3, hasType(xp), 2, 1), node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF1, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF1, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF1, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF1, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF1, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF1, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF1, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: getType evF2 %%%%%%%%%%%%%%%
tvd(getType, evF2, hasType, [y1], [1], 3, [node(3, eq(y1, xp), 1, 2), node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF2, goesIn, [y1, y2], [_, _], 5, [node(5, eq(f2, y2), 4, 2), node(4, eq(y1, xp), 3, 2), node(3, hasType(xp), 2, 1), node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF2, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF2, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF2, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF2, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF2, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF2, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF2, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: getType evF3 %%%%%%%%%%%%%%%
tvd(getType, evF3, hasType, [y1], [1], 3, [node(3, eq(y1, xp), 1, 2), node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF3, goesIn, [y1, y2], [_, _], 5, [node(5, eq(f3, y2), 4, 2), node(4, eq(y1, xp), 3, 2), node(3, hasType(xp), 2, 1), node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF3, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF3, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF3, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF3, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF3, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF3, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF3, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: getType evF4 %%%%%%%%%%%%%%%
tvd(getType, evF4, hasType, [y1], [1], 3, [node(3, eq(y1, xp), 1, 2), node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF4, goesIn, [y1, y2], [_, _], 5, [node(5, eq(f4, y2), 4, 2), node(4, eq(y1, xp), 3, 2), node(3, hasType(xp), 2, 1), node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF4, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF4, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF4, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF4, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF4, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF4, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getType, evF4, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%% TVD: getFolderF0 succ %%%%%%%%%%%%%%%
tvd(getFolderF0, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF0, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF0, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF0, succ, haveF0, [], [], 5, [node(5, haveF1, 0, 4), node(4, haveF2, 0, 3), node(3, haveF3, 0, 2), node(2, haveF4, 0, 1), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF0, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF0, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF0, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF0, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF0, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: getFolderF1 succ %%%%%%%%%%%%%%%
tvd(getFolderF1, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF1, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF1, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF1, succ, haveF1, [], [], 5, [node(5, haveF0, 0, 4), node(4, haveF2, 0, 3), node(3, haveF3, 0, 2), node(2, haveF4, 0, 1), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF1, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF1, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF1, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF1, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF1, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: getFolderF2 succ %%%%%%%%%%%%%%%
tvd(getFolderF2, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF2, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF2, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF2, succ, haveF2, [], [], 5, [node(5, haveF0, 0, 4), node(4, haveF1, 0, 3), node(3, haveF3, 0, 2), node(2, haveF4, 0, 1), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF2, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF2, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF2, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF2, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF2, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: getFolderF3 succ %%%%%%%%%%%%%%%
tvd(getFolderF3, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF3, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF3, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF3, succ, haveF3, [], [], 5, [node(5, haveF0, 0, 4), node(4, haveF1, 0, 3), node(3, haveF2, 0, 2), node(2, haveF4, 0, 1), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF3, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF3, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF3, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF3, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF3, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: getFolderF4 succ %%%%%%%%%%%%%%%
tvd(getFolderF4, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF4, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF4, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF4, succ, haveF4, [], [], 5, [node(5, haveF0, 0, 4), node(4, haveF1, 0, 3), node(3, haveF2, 0, 2), node(2, haveF3, 0, 1), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF4, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF4, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF4, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF4, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(getFolderF4, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%% TVD: fileF0 succ %%%%%%%%%%%%%%%
tvd(fileF0, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF0, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF0, succ, filed, [y1], [1], 6, [node(6, eq(y1, xp), 5, 2), node(5, hasType(xp), 4, 0), node(4, goesIn(xp, f0), 3, 0), node(3, haveF0, 1, 0), node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF0, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF0, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF0, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF0, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF0, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF0, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: fileF1 succ %%%%%%%%%%%%%%%
tvd(fileF1, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF1, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF1, succ, filed, [y1], [1], 6, [node(6, eq(y1, xp), 5, 2), node(5, hasType(xp), 4, 0), node(4, goesIn(xp, f1), 3, 0), node(3, haveF1, 1, 0), node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF1, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF1, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF1, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF1, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF1, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF1, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: fileF2 succ %%%%%%%%%%%%%%%
tvd(fileF2, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF2, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF2, succ, filed, [y1], [1], 6, [node(6, eq(y1, xp), 5, 2), node(5, hasType(xp), 4, 0), node(4, goesIn(xp, f2), 3, 0), node(3, haveF2, 1, 0), node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF2, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF2, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF2, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF2, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF2, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF2, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: fileF3 succ %%%%%%%%%%%%%%%
tvd(fileF3, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF3, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF3, succ, filed, [y1], [1], 6, [node(6, eq(y1, xp), 5, 2), node(5, hasType(xp), 4, 0), node(4, goesIn(xp, f3), 3, 0), node(3, haveF3, 1, 0), node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF3, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF3, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF3, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF3, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF3, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF3, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: fileF4 succ %%%%%%%%%%%%%%%
tvd(fileF4, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF4, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF4, succ, filed, [y1], [1], 6, [node(6, eq(y1, xp), 5, 2), node(5, hasType(xp), 4, 0), node(4, goesIn(xp, f4), 3, 0), node(3, haveF4, 1, 0), node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF4, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF4, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF4, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF4, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF4, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(fileF4, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%% TVD: returnF0 succ %%%%%%%%%%%%%%%
tvd(returnF0, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF0, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF0, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF0, succ, haveF0, [], [], 0, [node(0, 0.0, -1, -1)]).
tvd(returnF0, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF0, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF0, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF0, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF0, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: returnF1 succ %%%%%%%%%%%%%%%
tvd(returnF1, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF1, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF1, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF1, succ, haveF1, [], [], 0, [node(0, 0.0, -1, -1)]).
tvd(returnF1, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF1, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF1, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF1, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF1, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: returnF2 succ %%%%%%%%%%%%%%%
tvd(returnF2, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF2, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF2, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF2, succ, haveF2, [], [], 0, [node(0, 0.0, -1, -1)]).
tvd(returnF2, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF2, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF2, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF2, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF2, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: returnF3 succ %%%%%%%%%%%%%%%
tvd(returnF3, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF3, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF3, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF3, succ, haveF3, [], [], 0, [node(0, 0.0, -1, -1)]).
tvd(returnF3, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF3, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF3, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF3, succ, haveF4, [], [], 2, [node(2, haveF4, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF3, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: returnF4 succ %%%%%%%%%%%%%%%
tvd(returnF4, succ, hasType, [y1], [1], 2, [node(2, hasType(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF4, succ, goesIn, [y1, y2], [_, _], 2, [node(2, goesIn(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF4, succ, filed, [y1], [1], 2, [node(2, filed(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF4, succ, haveF4, [], [], 0, [node(0, 0.0, -1, -1)]).
tvd(returnF4, succ, haveF1, [], [], 2, [node(2, haveF1, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF4, succ, haveF2, [], [], 2, [node(2, haveF2, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF4, succ, haveF3, [], [], 2, [node(2, haveF3, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF4, succ, haveF0, [], [], 2, [node(2, haveF0, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).
tvd(returnF4, succ, eq, [y1, y2], [_, _], 2, [node(2, eq(y1, y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%%% GENERAL BACKGROUND KNOWLEDGE %%%%%%%%%%%%%%%%%%%%%%%%

rule(eq(A, B), [1, 1], [eq(B, A)]).
rule(eq(A, B), [1, 1], [eq(C, D), eq(A,C), eq(B,D)]).

rule(not_eq(A, B), [1, 1], [not_eq(B, A)]).
rule(not_eq(A, B), [1, 1], [not_eq(C, D), eq(A,C), eq(B,D)]).


%%%%%%%%%%%%% DOMAIN SPECIFIC BACKGROUND KNOWLEDGE %%%%%%%%%%%%%%%%%%%%%%%%


rule(eq(A, B), [1, 1], [goesIn(C,A), goesIn(D,B), eq(C,D)]).
rule(eq(A, B), [1, 1], [hasType(C, A), hasType(D, B), eq(C, D)]).

rule(not_haveF0, [], [haveF1]).
rule(not_haveF0, [], [haveF2]).
rule(not_haveF0, [], [haveF3]).
rule(not_haveF0, [], [haveF4]).

rule(not_haveF1, [], [haveF0]).
rule(not_haveF1, [], [haveF2]).
rule(not_haveF1, [], [haveF3]).
rule(not_haveF1, [], [haveF4]).

rule(not_haveF2, [], [haveF0]).
rule(not_haveF2, [], [haveF1]).
rule(not_haveF2, [], [haveF3]).
rule(not_haveF2, [], [haveF4]).

rule(not_haveF3, [], [haveF0]).
rule(not_haveF3, [], [haveF1]).
rule(not_haveF3, [], [haveF2]).
rule(not_haveF3, [], [haveF4]).

rule(not_haveF4, [], [haveF0]).
rule(not_haveF4, [], [haveF1]).
rule(not_haveF4, [], [haveF2]).
rule(not_haveF4, [], [haveF3]).

rule(goesIn(A, B), [1, 1], [goesIn(C, D), eq(A, C), eq(B, D)]).

rule(not_goesIn(A, B), [1, 1], [goesIn(C, D), eq(A, C), not_eq(B, D)]).
rule(not_goesIn(A, B), [1, 1], [not_goesIn(C, D), eq(A, C), eq(B, D)]).
rule(not_goesIn(A, B), [1, 1], [not_hasType(A), eq(B, B)]).

rule(hasType(A), [1], [hasType(C), eq(A, C)]).
